import keras
from keras.layers import Conv2D, Dense, Flatten, MaxPool2D, Softmax
import cv2
import numpy as np
from keras.datasets import mnist
(x_train, y_train), (x_test, y_test) = mnist.load_data()

x_train = x_train/255
x_train = np.reshape(x_train, (60000, 28, 28, 1))
x_test = x_test/255
x_test = np.reshape(x_test, (10000, 28, 28, 1))

y_train = keras.utils.to_categorical(y_train)
y_test = keras.utils.to_categorical(y_test)

myModel = keras.Sequential()
myModel.add(Conv2D(6, (3, 3),input_shape=(28, 28, 1) , activation="relu"))
myModel.add(MaxPool2D())
myModel.add(Flatten())
myModel.add(Dense(10, activation=None))
myModel.add(Softmax())
myModel.summary()
myModel.compile(keras.optimizers.SGD(lr=0.01), loss="categorical_crossentropy", metrics=['acc'])
myModel.fit(x=x_train, y=y_train, batch_size=200, epochs=10, validation_split=0.2)

my_new_model = keras.Model(myModel.inputs, myModel.layers[-2].output)
my_new_model.summary()
#weights1 = myModel.get_weights()
#weights2 = my_new_model.get_weights()
#print(weights1)
#print(weights2)
my_new_model.save("mnist.h5")

