/**
 * @file      KdpFMcomparison.h
 * @brief     header file for feature map comparison 
 * @version   0.1 - 2019-11-16
 * @copyright (c) 2019 Kneron Inc. All right reserved.
 */

#ifndef __KDP_FM_COMPARISON_H__
#define __KDP_FM_COMPARISON_H__

/**
 * @brief Calculate similarity of two feature points
 * @param user_fm_a buffer A of user feature map data
 * @param user_fm_b buffer B of user feature map data
 * @param fm_size   size of user feature map data
 * @return similarity score,smaller score are more similar
 *         errcode -1:parameter error
 * @note  user must ensure buffer A and B are the same size 
 */
float kdp_FM_comparison(char *user_fm_a, char *user_fm_b, int fm_size);

#endif
