/**
 * @file      user_test_del.cpp
 * @brief     kdp host lib user test examples 
 * @version   0.1 - 2019-04-25
 * @copyright (c) 2019 Kneron Inc. All right reserved.
 */

#include "stdio.h"
#include "errno.h"
#include "kdp_host.h"
#include "user_util.h"

#include <string.h>
#include <unistd.h>

#if defined (__cplusplus) || defined (c_plusplus)
extern "C"{
#endif

int user_test(int dev_idx, int user_id) 
{
#if 0
    //delete all user
    uint32_t _id = user_id;

    uint32_t rgb_size = 0;
    uint32_t nir_size = 0;
    float rgb_thresh  = 0;
    float nir_thresh  = 0;
    printf("starting lw3d mode ...\n");
    int ret = kdp_start_lw3d_mode_thresh(dev_idx, &rgb_size, &nir_size,
                                         rgb_thresh, nir_thresh);
    if (ret != 0) {
        printf("could not start lw3d mode ..\n");
        return -1;
    }
    printf("start lw3d mode succeeded...\n");
    usleep(SLEEP_TIME);
    printf("removing user ...\n");
    ret = kdp_remove_user(dev_idx, _id);
    if(ret != 0) {
        printf("remove all user failed.\n");
    }
    printf("removing user succeeded ...\n");
#endif

#if 1
    uint32_t _id      = user_id;
    uint32_t img_size = 0;
    printf("starting verify mode ...\n");
    //int ret = kdp_start_verify_mode(dev_idx, &img_size);
    int ret = kdp_start_verify_mode_thresh(dev_idx, &img_size, THRESHOLD_DEFAULT);
    if (ret != 0 || img_size == 0) {
        printf("start verify mode failed :%d, buf size:%d.\n", ret, img_size);
        return -1;
    }
    printf("starting verify mode successfuly, img size:%d...\n", img_size);

    usleep(SLEEP_TIME);

    printf("removing user ...\n");
    ret = kdp_remove_user(dev_idx, _id);
    if (ret != 0) {
        printf("remove all user failed.\n");
    }
    printf("removing user succeeded ...\n");
#endif
    return 0;
}

#if defined (__cplusplus) || defined (c_plusplus)
}
#endif
