/**
 * @file      user_test_fw.cpp
 * @brief     kdp host lib user test examples 
 * @version   0.1 - 2019-08-01
 * @copyright (c) 2019 Kneron Inc. All right reserved.
 */

#include "errno.h"
#include "kdp_host.h"
#include "stdio.h"

#include <string.h>
#include <unistd.h>
#include "user_util.h"

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

#define FW_SCPU_FILE (TEST_OTA_DIR "/work1/fw_scpu_ota.bin")
#define FW_NCPU_FILE (TEST_OTA_DIR "/work1/fw_ncpu_ota.bin")
#define FW_FILE_SIZE (128 * 1024)


//user test update firmware
int user_test_fw(int dev_idx, int user_id)
{
    //udt firmware
    uint32_t module_id = user_id;
    char img_buf[FW_FILE_SIZE];
    uint32_t buf_len = 0;
    int buf_len_ret = 0;

    if(module_id != 0 && module_id != 1 && module_id != 2) {
        printf("invalid module id:%d ...\n", user_id);
        return -1;
    }

    printf("starting update fw ...\n");

    if(module_id == 1) {
        buf_len_ret = read_file_to_buf(img_buf, FW_SCPU_FILE, FW_FILE_SIZE);
    } else {
        buf_len_ret = read_file_to_buf(img_buf, FW_NCPU_FILE, FW_FILE_SIZE);
    }

    if (buf_len_ret  <= 0) {
        printf("reading file to buf failed:%d...\n", buf_len_ret);
        return -1;
    }
    else {
        buf_len = buf_len_ret;
    }

    int ret = kdp_update_fw(dev_idx, &module_id, img_buf, buf_len);
    if (ret != 0) {
        printf("could not update fw..\n");
        return -1;
    }

    printf("update firmware succeeded...\n");

    return 0;
}


int user_test(int dev_idx, int user_id)
{
    //udt firwmare test
    user_test_fw(dev_idx, user_id);

    return 0;
}

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif
