#ifndef __KL520_API_H__
#define __KL520_API_H__

#include "base.h"
#include "kl520_include.h"

/*-----------------------------------------------------------------------
 *                          Display layout API 
 *-----------------------------------------------------------------------*/
/**
* @brief  Setup driver and turn on display
*
* @param  cam_idx: camera source on dispaly
* 
* @return TRUE: succeed to setup/init display driver
*         FALSE: fail to setup/init display driver
*/
bool kl520_api_dp_open(uint8_t cam_idx, unsigned int width, unsigned int height, unsigned int pixelformat);

/**
* Stop/Close display preview
*
* @param  N/A
* 
* @return N/A
*/
void kl520_api_dp_close(void);

/**
* Get display init. status
*
* @param  N/A
* 
* @return TRUE: initialized\n
*         FALSE: not initialized
*/
bool kl520_api_dp_init_get(void);


/*ToDo*/
void kl520_api_dp_layout_enable(void);
void kl520_api_dp_layout_disable(void);
bool kl520_api_dp_layout_get(void);
void kl520_api_dp_layout(void);
void kl520_api_dp_layout_fd_ok(struct kdp_rect *lp_rect);
void kl520_api_dp_layout_db_ok(struct kdp_rect *lp_rect);
uint16_t kl520_api_dp_layout_fd_hint(struct kdp_rect *lp_rect);

#endif
