#include "kl520_api_device_id.h"
#include "kl520_api_fdfr.h"
#include "kdp_memxfer.h"
#include "rtc.h"
#include "power.h"
#include "version.h"
#include "dbg.h"
#include "kdp_system.h"

void kl520_api_factory(void)
{
    //kl520_api_face_del(1, (u8)0);
}

void kl520_api_poweroff(void)
{
    //kl520_api_face_close();

    DSG("!!! shutdown ...\n\n");

    /* Disable alarm */
    rtc_alarm_disable(ALARM_IN_SECS);

    /* Power off everything except RTC */
    power_mgr_softoff(POWER_MGR_MODE_RTC);
    __WFI();

    DSG("!!! shutdown failed!\n");
    for (;;);
    
}

static u32 kl520_api_get_unique_id(void) {
    return kdp_sys_get_unique_id();
}

static u8 kl520_api_memxfer_get_device_id(void) {
    return kdp_memxfer_module.flash_get_device_id();
}

static u16 kl520_api_camera_rgb_get_device_id(void) {
    return sc132gs_get_device_id();
}

static u16 kl520_api_camera_nir_get_device_id(void) {
    return gc2145_get_device_id();
}
#if 0
static u16 kl520_api_io_ext_get_device_id(void) {
    return io_extender_get_device_id();
}
#endif
void kl520_api_get_device_info(system_info* t_system_info)
{
    //TODO : get fw version and kl520 id.
    t_system_info->unique_id = kl520_api_get_unique_id();
    t_system_info->spl_version = kdp_sys_get_spl_version();
    t_system_info->fw_scpu_version = ((g_fw_misc.major<<24)|(g_fw_misc.minor<<16)|(g_fw_misc.update<<8)|(g_fw_misc.build));
    t_system_info->fw_ncpu_version = kdp_sys_get_ncpu_version();
    t_system_info->device_id_0.device_name = "sc132gs";
    t_system_info->device_id_0.id = kl520_api_camera_rgb_get_device_id();
    t_system_info->device_id_1.device_name = "gc2145";
    t_system_info->device_id_1.id = kl520_api_camera_nir_get_device_id();
    t_system_info->device_id_2.device_name = "nor flash";
    t_system_info->device_id_2.id = (u32)kl520_api_memxfer_get_device_id();
    t_system_info->device_id_3.device_name = "st7789v";
    t_system_info->device_id_3.id = kdp_display_get_device_id();
    //t_system_info->device_id_4.device_name = "ct130";
    //t_system_info->device_id_4.id = kl520_api_touch_get_device_id();
    //t_system_info->device_id_5.device_name = "aw9523b";
    //t_system_info->device_id_5.id = kl520_api_io_ext_get_device_id();
}

