#ifndef __SAMPLE_APP_TOUCH_H__
#define __SAMPLE_APP_TOUCH_H__

#include "ui_fsm_proto.h"
#include "user_ui.h"


#define TOUCH_CLICK_MAX_NUM     (10)
#define TOUCH_EVENT_MAX_NUM     (20)

#define TOUCH_CLICK_RANGE       (40)
#define TOUCH_CLICK_RANGE_1     (50)
#define TOUCH_RETURN_X          (50)
#define TOUCH_RETURN_Y          (270)
#define TOUCH_INFE_X            (50)
#define TOUCH_INFE_Y            (50)
#define TOUCH_REG_OPEN_X        (190)
#define TOUCH_REG_OPEN_Y        (50)
#define TOUCH_REG_START_X       (120)
#define TOUCH_REG_START_Y       (160)
#define TOUCH_REG_DELETE_X      (190)
#define TOUCH_REG_DELETE_Y      (270)


typedef enum __e_touch_status
{
    TOUCH_INACTIVE = 0,
    TOUCH_CLICK_ACTIVE,
    //TOUCH_SLIDE_ACTIVE,
} e_touch_status;

typedef struct __touch_type_click
{
    user_behavior_type ui_event;//leave it to fsm?
    u16 x;
    u16 y;
    u16 range;
    e_touch_status status;
    fsm_state activate_state;
} touch_type_click;

typedef struct __t_app_touch_data
{
    u32 input_x[TOUCH_CLICK_MAX_NUM];
    u32 input_y[TOUCH_CLICK_MAX_NUM];
    u8 count;
} t_app_touch_data;


void sample_app_init_touch_panel(void);
extern void sample_app_touch_point_setting(u8 id,  u16 input_x, u16 input_y);
extern void sample_app_touch_count_setting(u8 cnt);

#endif
