#include "sample_kdp_fdr.h"
#include <cmsis_os2.h>
#include <string.h>
#include "base.h"
#include "io.h"
#include "kdp_memory.h"
#include "pinmux.h"
#include "framework/init.h"
#include "framework/v2k_image.h"
#include "framework/event.h"
#include "kdp_app.h"
#include "kdp_app_fid.h"
#include "kdp_app_lw3d.h"
#include "kdp_app_db.h"
#include "utility.h"
#include "dbg.h"
#include "media/display/lcdc.h"
#include "media/camera/sensor.h"
#include "media/kdp_inference.h"
//todo

static int distance_flag = 0;
static int rgb_fd_get_flag = 0;

static kdp_app_fid_inout_t     *m_fdr_inout = NULL;
static kdp_app_face_det_res_t  *m_fd_out  = NULL;
static kdp_app_face_fmap_t     *m_fr_out  = NULL;
static kdp_app_db_user_data_t  *m_db_data = NULL;
static kdp_app_face_fmap_t     *m_fr_1_out  = NULL;
extern const struct s_kdp_memxfer kdp_memxfer_module;
extern bool m_show_txt;
//todo unify fd structure
extern struct kdp_rect m_boundingbox;

//todo
#define NUM_REG_INFERENCE 				20
#define FM_SIZE                   512
#define FM_SIZE_BYTE              (FM_SIZE * 4)

#define LM_SIZE										10
#define LM_SIZE_BYTE							(LM_SIZE * 4)	

#define REG_TEMP_FR_SIZE					(FM_SIZE_BYTE * NUM_REG_INFERENCE)
#define REG_TEMP_LM_SIZE					(LM_SIZE_BYTE * NUM_REG_INFERENCE)

static uint32_t *db_tmp_lm = 0;
static float *db_tmp_fr = 0;
static uint32_t *db_tmp_1_lm = 0;
static float *db_tmp_1_fr = 0;

//todo change to use kdp_app_face_fmap_t and lm structure
// static uint32_t *db_tmp_lm = 0;
// static float *db_tmp_fr = 0;

static int _sample_kneron_reg_fdr_only(struct kdp_rect*, int);
    
static int _sample_kneron_reg_fdr_both_only(struct kdp_rect *lp_rect, int index)
{
    int ret, ret0, ret1;

    do {
        m_fdr_inout->op = KDP_APP_FID_OP_EXTRACT;
        ret0 = kdp_app_fdr(m_fdr_inout, m_fd_out, (kdp_app_face_lm_res_t*)&db_tmp_lm[index*10], (kdp_app_face_fmap_t*)&db_tmp_fr[index*512]);
        ret1 = kdp_app_nir_fdr_only(NULL, NULL, (kdp_app_face_lm_res_t*)&db_tmp_1_lm[index*10], (kdp_app_face_fmap_t*)&db_tmp_1_fr[index*512]);
			  //ret1 = kdp_app_lw3d_fdr(1);
			   
            
        dbg_msg("[%s] ret=0x%x\n", __func__, ret);
			
        if ((KDP_APP_FDR_NO_FACE != ret0) && (KDP_APP_FDR_NO_FACE != ret1))
        {
            lp_rect->start_x = (u16) m_fd_out->xywh[0];
            lp_rect->start_y = (u16) m_fd_out->xywh[1];
            lp_rect->end_x = ((u16) m_fd_out->xywh[0]) + ((u16) m_fd_out->xywh[2]);
            lp_rect->end_y = ((u16) m_fd_out->xywh[1]) + ((u16) m_fd_out->xywh[3]);
            //boundingbox_new_total = lp_rect->start_x + lp_rect->start_y + lp_rect->end_x + lp_rect->end_y;
            ret = ret0; //might be some cases left for different status of ret1
        }
        else {
            ret = KDP_APP_FDR_NO_FACE;
            info_msg("[inference] FD result : NO FACE\n");
            break;
        }
        
    } while (0);

    return ret;
}

static int _sample_kneron_fdr_both_only(struct kdp_rect *lp_rect)
{
    int ret, lw3d_ret;
    fdr_result fdr_ret = FDR_RET_OOPS;
    do {
        m_fdr_inout->op = KDP_APP_FID_OP_EXTRACT;
        //ret = kdp_app_fdr_only(m_fdr_inout, m_fd_out, NULL, m_fr_out);
        ret = kdp_app_fdr(m_fdr_inout, m_fd_out, NULL, m_fr_out);
        dbg_msg("[%s] ret=0x%x\n", __func__, ret);
        if (KDP_APP_FDR_NO_FACE != ret)
        {
            lp_rect->start_x = (u16) m_fd_out->xywh[0];
            lp_rect->start_y = (u16) m_fd_out->xywh[1];
            lp_rect->end_x = ((u16) m_fd_out->xywh[0]) + ((u16) m_fd_out->xywh[2]);
            lp_rect->end_y = ((u16) m_fd_out->xywh[1]) + ((u16) m_fd_out->xywh[3]);

        }
        else {
            info_msg("[inference] FD result : NO FACE\n");
            //break;
        }

        if (ret == KDP_APP_FDR_NO_FACE){
            // if no face, aec_roi set as 480x480 rgb right img 
            if (rgb_fd_get_flag == 0){
                //dbg_msg(" rgb_fd_get_flag  = 0 ");
            }else{
                rgb_fd_get_flag = 0;
                rgb_set_aec_roi(20, 80, 0, 60, 30, 70, 10, 50);
                //dbg_msg("set rgb_fd_get_flag = 0 ");
            }        
        }else{ // if get face, aec_roi set as fd region.
            
            u8 xmin_inter = (u8) (m_fd_out->xywh[0] >> 3);
            u8 xmax_inter = (u8) ( (m_fd_out->xywh[0] + m_fd_out->xywh[2]) >> 3 );
            u8 ymin_inter = (u8) (m_fd_out->xywh[1] >> 3);
            u8 ymax_inter = (u8) ( (m_fd_out->xywh[1] + m_fd_out->xywh[3]) >> 3 );
            
            if( (xmin_inter >= 20) && (ymin_inter >= 0) ){ // if get face and fd region in rgb right region(480x480)
        
                if (rgb_fd_get_flag == 1){
                    //dbg_msg(" rgb_fd_get_flag = 1 ");
                }else{
                    rgb_fd_get_flag = 1;
                    rgb_set_aec_roi(20, 80, 0, 60, xmin_inter, xmax_inter, ymin_inter, ymax_inter);
                }
            }else{ // if fd region not in rgb right region (480x480)
                
                if (rgb_fd_get_flag == 0){
                    //dbg_msg(" rgb_fd_get_flag  = 0 ");
                }else{
                    rgb_fd_get_flag = 0;
                    rgb_set_aec_roi(20, 80, 0, 60, 30, 70, 10, 50);
                    //dbg_msg("set rgb_fd_get_flag = 0 ");
                }
            }
            int DIST_W = m_fd_out->xywh[2];
            //dbg_msg("DIST_W = %d \n", DIST_W);
            if( DIST_W >= 256 ){  // short distance  
                if( distance_flag == 0 ){
                    dbg_msg(" nir gain as 6 \n");
                }else{
                    distance_flag = 0;
                    nir_set_gain(0x27, 0x35); // nir set gain as 6
                    dbg_msg("set nir gain = 6 \n");
                }
            }
            else if ( DIST_W < 256 ){ // long distance
                if( distance_flag == 1 ){
                    dbg_msg(" nir gain as 12 \n");
                }else{
                    distance_flag = 1;
                    nir_set_gain(0x2F, 0x35); // nir set gain as 12
                    dbg_msg("set nir gain = 12\n");
                }
            }
        }
        lw3d_ret = kdp_app_nir_fdr(distance_flag, m_fdr_inout, NULL, NULL, m_fr_1_out);
        info_msg("[inference] finish LW3D");

        m_fdr_inout->thresh_fid = 0.425;
        // fdr_ret = kdp_app_db_lw3d_compare((uint32_t)m_fr_out->feature_map, (uint32_t)m_fr_1_out->feature_map, &(m_fdr_inout->user_id), m_fdr_inout->thresh_fid);
        fdr_ret = kdp_app_db_lw3d_compare_rgb_nir(
                (uint32_t)m_fr_out->feature_map, 0.5 /*rgb_weight*/, 
                (uint32_t)m_fr_1_out->feature_map, 0.5 /*nir_weight*/, 
                &(m_fdr_inout->user_id), m_fdr_inout->thresh_fid);
        
        info_msg("[inference] finish LW3D compare, close is id %d\n", m_fdr_inout->user_id);
        if (fdr_ret == KDP_APP_OK) {
                info_msg("[inference] LW3D Passed, match with id %d\n",  m_fdr_inout->user_id);
        }         
        else
        {
                fdr_ret = FDR_RET_DB_COMP_FAIL;
                info_msg("[inference] Not Match\n");
        }

        if(fdr_ret != FDR_RET_DB_COMP_FAIL){
            if(KDP_APP_FDR_NO_ALIVE != lw3d_ret){
                fdr_ret = FDR_RET_DB_COMP_OK;
            }else{
                info_msg("[inference] LW3D Failed\n");
                fdr_ret = FDR_RET_OK;
            }
        }
               
        
    } while (0);

    return fdr_ret;
}


bool sample_kneron_fdr_model_init(void)
{  
    int j;
    int saved_count;

    if(m_fdr_inout == NULL)
        m_fdr_inout = (kdp_app_fid_inout_t*)kdp_ddr_reserve(sizeof(kdp_app_fid_inout_t));
    if(m_fd_out == NULL)
        m_fd_out = (kdp_app_face_det_res_t*)kdp_ddr_reserve(sizeof(kdp_app_face_det_res_t));
    if(m_fr_out == NULL)
        m_fr_out = (kdp_app_face_fmap_t*)kdp_ddr_reserve(sizeof(kdp_app_face_fmap_t));

    if(m_fr_1_out == NULL)
        m_fr_1_out = (kdp_app_face_fmap_t*)kdp_ddr_reserve(sizeof(kdp_app_face_fmap_t));

    if(m_db_data == NULL)
        m_db_data = (kdp_app_db_user_data_t*)kdp_ddr_reserve(sizeof(kdp_app_db_user_data_t));
    //todo
    if (db_tmp_fr == NULL) 
            db_tmp_fr = (float *)kdp_ddr_reserve(sizeof(uint8_t)*REG_TEMP_FR_SIZE); 
    if (db_tmp_lm == NULL)
            db_tmp_lm = (uint32_t *)kdp_ddr_reserve(sizeof(uint8_t)*REG_TEMP_LM_SIZE); 

    if (db_tmp_1_fr == NULL) 
            db_tmp_1_fr = (float *)kdp_ddr_reserve(sizeof(uint8_t)*REG_TEMP_FR_SIZE); 
    if (db_tmp_1_lm == NULL)
            db_tmp_1_lm = (uint32_t *)kdp_ddr_reserve(sizeof(uint8_t)*REG_TEMP_LM_SIZE);  

    saved_count = kdp_app_init();
    kdp_app_config_image(0/*cam_index*/, RGB_IMG_SOURCE_W, RGB_IMG_SOURCE_H, 3, KDP_APP_IMAGE_FORMAT_RGB565, 0/*default addr*/);
    //kdp_app_config_image(1/*cam_index*/, NIR_IMG_SOURCE_CROP_H, NIR_IMG_SOURCE_CROP_W, 1, KDP_APP_IMAGE_FORMAT_RAW8, NIR_DDR_BUF_ADDR);
    kdp_app_config_image(1/*cam_index*/, NIR_IMG_SOURCE_CROP_H, NIR_IMG_SOURCE_CROP_W, 1, KDP_APP_IMAGE_FORMAT_RAW8, 0x6357C400);
#ifdef SAMPLE_DB_API
    kdp_app_db_init(KDP_APP_DB_FLASH_ADDR);     //load db from flash
#endif

    //init m_sample_db.add_tag according to existed data in DB
    for (j=0 ; j<MAX_USER;j++) {
        if(saved_count == 0)
            break;
            
        if(kdp_app_db_slot_is_used(j)) {
            saved_count--;
        }
    }
        
    return TRUE;
}

fdr_result sample_kneron_fdr_inference(void)
{
    fdr_result fdr_ret = FDR_RET_OOPS;
    int ret = -1;
    int32_t lw3d_ret;
    struct kdp_rect *lp_rect = &m_boundingbox;

    m_fdr_inout->op = KDP_APP_FID_OP_INFERENCE;
    m_fdr_inout->thresh_fid = 0.425;

    do {
        //todo dummy
        memset(m_fd_out, 0, sizeof(kdp_app_face_det_res_t));
        memset(m_fr_out, 0, sizeof(kdp_app_face_fmap_t));   
        
        // get exp time
        u16 a = 0;
        u8 b, c;
        //todo need rename
        rgb_get_lux( &a , &b , &c );
        //dbg_msg("exp_rgb_time = %d", a);
        
        ret = kdp_app_fdr(m_fdr_inout, m_fd_out, NULL, m_fr_out);
        
        if (ret == KDP_APP_FDR_NO_FACE ){
            info_msg("[inference] FD result : NO FACE\n");
            // if no face, aec_roi set as 480x480 rgb right img 
            if (rgb_fd_get_flag == 0){
                //dbg_msg(" rgb_fd_get_flag  = 0 ");
            }else{
                //todo need rename
                rgb_fd_get_flag = 0;
                rgb_set_aec_roi(20, 80, 0, 60, 30, 70, 10, 50);
                //dbg_msg("set rgb_fd_get_flag = 0 ");
            }    
        }else if (ret == KDP_APP_FDR_WRONG_USAGE ||   ret == KDP_APP_FDR_BAD_POSE || ret == KDP_APP_FDR_NO_ALIVE || ret == KDP_APP_FDR_FR_FAIL ||
         ret == KDP_APP_LM_LOW_CONFIDENT || ret == KDP_APP_LM_BLUR ){
         info_msg("other than KDP_APP_FDR_NO_FACE ret : %d\n", ret);  
    
        }else{ // if get face, aec_roi set as fd region.
            lp_rect->start_x = (u16) m_fd_out->xywh[0];
            lp_rect->start_y = (u16) m_fd_out->xywh[1];
            lp_rect->end_x = ((u16) m_fd_out->xywh[0]) + ((u16) m_fd_out->xywh[2]);
            lp_rect->end_y = ((u16) m_fd_out->xywh[1]) + ((u16) m_fd_out->xywh[3]);

            u8 xmin_inter = (u8) (m_fd_out->xywh[0] >> 3);
            u8 xmax_inter = (u8) ( (m_fd_out->xywh[0] + m_fd_out->xywh[2]) >> 3 );
            u8 ymin_inter = (u8) (m_fd_out->xywh[1] >> 3);
            u8 ymax_inter = (u8) ( (m_fd_out->xywh[1] + m_fd_out->xywh[3]) >> 3 );
            
            if(xmin_inter >= 20){ // if get face and fd region in rgb right region(480x480)
        
                if (rgb_fd_get_flag == 1){
                    //dbg_msg(" rgb_fd_get_flag = 1 ");
                }else{
                    rgb_fd_get_flag = 1;
                    rgb_set_aec_roi(20, 80, 0, 60, xmin_inter, xmax_inter, ymin_inter, ymax_inter);
                }
            }else{ // if fd region not in rgb right region (480x480)
                
                if (rgb_fd_get_flag == 0){
                    //dbg_msg(" rgb_fd_get_flag  = 0 ");
                }else{
                    rgb_fd_get_flag = 0;
                    rgb_set_aec_roi(20, 80, 0, 60, 30, 70, 10, 50);
                    //dbg_msg("set rgb_fd_get_flag = 0 ");
                }
            }
            int DIST_W = m_fd_out->xywh[2];
            //dbg_msg("DIST_W = %d \n", DIST_W);
            if( DIST_W >= 256 ){  // short distance  
                if( distance_flag == 0 ){
                    dbg_msg(" nir gain as 6 \n");
                    //DSG(" nir gain as 6 \n");
                }else{
                    distance_flag = 0;
                    nir_set_gain(0x27, 0x35); // nir set gain as 6
                    dbg_msg("set nir gain = 6 \n");
                }
            }
            else if ( DIST_W < 256 ){ // long distance
                if( distance_flag == 1 ){
                    dbg_msg(" nir gain as 12 \n");
                    //DSG(" nir gain as 12 \n");
                }else{
                    distance_flag = 1;
                    nir_set_gain(0x2F, 0x35); // nir set gain as 12
                    dbg_msg("set nir gain = 12\n");
                }
            }
        }
        
        lw3d_ret = kdp_app_lw3d_fdr(distance_flag);
        if (KDP_APP_OK == ret ) {
            if ( KDP_APP_OK == lw3d_ret) {
                fdr_ret = FDR_RET_DB_COMP_OK;
            }else {
                info_msg("[inference] LW3D Failed\n");
                fdr_ret = FDR_RET_OK;
            }
		}
        else
        {
            fdr_ret = FDR_RET_DB_COMP_FAIL;
        }
    } while (0);
    
    return fdr_ret;
}

int sample_kneron_get_available_db_idx(void)
{
    return kdp_app_db_get_available_ID_slot();
}

int sample_kneron_get_remaining_fmap_cnt(int user_idx)
{
    return (MAX_FID - kdp_app_db_get_fm0_cnt(user_idx));
}

int sample_kneron_fdr_registration(u32 curr_user_idx)
{
    int ret = -1;

    do {
        //todo : should restructure 
        if ((curr_user_idx + 1) > DB_SLOT_SIZE)/*User id(curr_user_idx) starts from 0*/
        {
            info_msg("[registration] : No space\n");
            ret = KDP_APP_UNKNOWN_ERR;
            break;
        }
        else if (kdp_app_db_get_fm0_cnt(curr_user_idx) >= MAX_FID) {
            info_msg("[registration] : saved_fmap_cnt > MAX_FID(5)\n");
            ret = KDP_APP_OK;
            break;
        }
        else {
            memset(m_fd_out, 0, sizeof(kdp_app_face_det_res_t));
            memset(m_fr_out, 0, sizeof(kdp_app_face_fmap_t));
 
            m_fdr_inout->op = KDP_APP_FID_OP_REGISTER;
            m_fdr_inout->face_id = kdp_app_db_get_fm0_cnt((int)curr_user_idx) + 1;  //start from 1
            m_fdr_inout->user_id = (uint16_t)curr_user_idx; 
            m_fdr_inout->thresh_fid = 0.425;

            ret = kdp_app_fdr(m_fdr_inout, m_fd_out, NULL, m_fr_out);
            if (KDP_APP_OK == ret) {
                info_msg("[registration] : -- OK!\n\n");
            }
            else if (KDP_APP_DB_ALREADY_SAVED == ret) {
                info_msg("[registration] : -- ERROR!, face has been registered\n\n");
            }
            else {
                info_msg("[registration] : -- ERROR!, err=0x%x\n\n", ret);
            }
            break;
        }
    } while (0);

    return ret;
}

#define KL520_THRESH_NORMAL_MAX             (30)
#define KL520_THRESH_LEFT_MIN               (55)
#define KL520_THRESH_LEFT_MAX               (80)
#define KL520_THRESH_RIGHT_MIN              (55)
#define KL520_THRESH_RIGHT_MAX              (80)
#define KL520_THRESH_UP_MIN                 (50)
#define KL520_THRESH_UP_MAX                 (65)
#define KL520_THRESH_DOWN_MIN               (50)
#define KL520_THRESH_DOWN_MAX               (65)

#define KL520_MIDDLE_LINE					(60)

uint8_t face_reg_thresh[] = {0, KL520_THRESH_NORMAL_MAX, KL520_THRESH_LEFT_MIN,  KL520_THRESH_LEFT_MAX,
                             KL520_THRESH_RIGHT_MIN, KL520_THRESH_RIGHT_MAX, KL520_THRESH_UP_MIN, KL520_THRESH_UP_MAX,
                             KL520_THRESH_DOWN_MIN, KL520_THRESH_DOWN_MAX
                            };
//Datang's 5 face register
int sample_kneron_5face_registration(u32 curr_user_idx, int type) {
    //DSG_NOLF(" sample_kneron_fdr_auto_reg!\n");
    int ret = -1;
    int pose_ret = -1;
    // db_tmp_valid_pose[type] = false;
    if ((curr_user_idx + 1) > DB_SLOT_SIZE)/*User id(curr_user_idx) starts from 0*/
    {
        info_msg("[registration] : No space\n");
        ret = KDP_APP_UNKNOWN_ERR;
        return ret;
    }
    //try different angle 5 faces
    ret = _sample_kneron_reg_fdr_only(&m_boundingbox, type);

    if(ret != KDP_APP_OK){
        return ret;
    }
    //left or up

    if (type==1 || type==3) {
        pose_ret = kdp_app_check_head_pose((kdp_app_face_lm_res_t*)&db_tmp_lm[type*10], type, 0, face_reg_thresh);
    } else  {
        pose_ret = kdp_app_check_head_pose((kdp_app_face_lm_res_t*)&db_tmp_lm[type*10], type, 1, face_reg_thresh);
    }

    if (pose_ret == -1) {
        return pose_ret;
    } else {
        //if normal face
        if (type==0) {
            //see if there is any one in the data base match this guy
            ret = kdp_app_db_compare((uint32_t)&db_tmp_fr[0], &m_fdr_inout->user_id, m_fdr_inout->thresh_fid);
            if(ret != KDP_APP_DB_NO_MATCH) {
                return KDP_APP_DB_ALREADY_SAVED;
            } else {
                //register normal face
                uint32_t fr_addr = (uint32_t)db_tmp_fr;
                ret = kdp_app_db_register(fr_addr, curr_user_idx, type);   
            }
        } else {
                uint32_t fr_addr = (uint32_t)db_tmp_fr+(type+1)*512*4;
                ret = kdp_app_db_register(fr_addr, curr_user_idx, type);                
        }
    }

    return ret;
}


static int _sample_kneron_reg_fdr_only(struct kdp_rect *lp_rect, int index)
{
    int ret;

    do {
        m_fdr_inout->op = KDP_APP_FID_OP_EXTRACT;  
        ret = kdp_app_fdr(m_fdr_inout, m_fd_out, (kdp_app_face_lm_res_t*)&db_tmp_lm[index*10], (kdp_app_face_fmap_t*)&db_tmp_fr[index*512]);
        dbg_msg("[%s] ret=0x%x\n", __func__, ret);
			
        if (KDP_APP_FDR_NO_FACE != ret)
        {
            lp_rect->start_x = (u16) m_fd_out->xywh[0];
            lp_rect->start_y = (u16) m_fd_out->xywh[1];
            lp_rect->end_x = ((u16) m_fd_out->xywh[0]) + ((u16) m_fd_out->xywh[2]);
            lp_rect->end_y = ((u16) m_fd_out->xywh[1]) + ((u16) m_fd_out->xywh[3]);
        }
        else {
            info_msg("[inference] FD result : NO FACE\n");
            break;
        }
        
    } while (0);

    return ret;
}

static bool db_tmp_valid_pose[NUM_REG_INFERENCE];

int sample_kneron_fdr_auto_reg(u32 curr_user_idx, int reg_index)
{
	//DSG_NOLF(" sample_kneron_fdr_auto_reg!\n");
    int ret = -1;
	  db_tmp_valid_pose[reg_index] = false;
    if ((curr_user_idx + 1) > DB_SLOT_SIZE)/*User id(curr_user_idx) starts from 0*/
    {
        info_msg("[registration] : No space\n");
        ret = KDP_APP_UNKNOWN_ERR;
        return ret;
    }

    ret = _sample_kneron_reg_fdr_only(&m_boundingbox, reg_index);
            
    //for (int j=0; j<10; j++) {
    //    DSG_NOLF(" lm %d is %d!\n", j, db_tmp_lm[reg_index*10+j]);
    //}

    if (ret == KDP_APP_OK) {
        //DSG_NOLF(" have face!\n");
		//fLib_printf("start_x: %hu\n", m_boundingbox.start_x);
		//fLib_printf("start_y: %hu\n", m_boundingbox.start_y);
		//fLib_printf("end_x: %hu\n", m_boundingbox.end_x);
		//fLib_printf("end_y: %hu\n", m_boundingbox.end_y);
        //check if it is bad pose
        bool bad_pose = kdp_app_check_bad_pose(&db_tmp_lm[reg_index*10]);
        if (!bad_pose) {
            //DSG_NOLF(" good pose for index %d!\n", reg_index);
            db_tmp_valid_pose[reg_index] = true;
        }
    }

    return ret;
}
int sample_kneron_fdr_both_reg(u32 curr_user_idx, int reg_index)
{
	DSG_NOLF(" sample_kneron_fdr_both_reg!\n");
    int ret = -1;
	  db_tmp_valid_pose[reg_index] = false;
    if ((curr_user_idx + 1) > DB_SLOT_SIZE)/*User id(curr_user_idx) starts from 0*/
    {
        info_msg("[registration] : No space\n");
        ret = KDP_APP_UNKNOWN_ERR;
        return ret;
    }

    ret = _sample_kneron_reg_fdr_both_only(&m_boundingbox, reg_index);
		//memcpy((const void *) 0x62000000, (const void *) 0x62FFE000, 640*480*2*sizeof(char));
	
    DSG_NOLF(" done %d both registration!\n", reg_index);
            
    for (int j=0; j<10; j++) {
        DSG_NOLF("RGB lm %d is %d, NIR lm is %d!\n", j, db_tmp_lm[reg_index*10+j], db_tmp_1_lm[reg_index*10+j]);
    }
    
    if (ret == KDP_APP_OK) {
        DSG_NOLF(" have face!\n");
        //check if it is bad pose
        bool rgb_bad_pose = kdp_app_check_bad_pose(&db_tmp_lm[reg_index*10]);
        bool nir_bad_pose = kdp_app_check_bad_pose(&db_tmp_1_lm[reg_index*10]);
        if (!rgb_bad_pose && !nir_bad_pose) {
            DSG_NOLF(" good pose for index %d!\n", reg_index);
            db_tmp_valid_pose[reg_index] = true;
        }
    }

    return ret;
}

fdr_result sample_kneron_fdr_both_inference(void)
{
    fdr_result fdr_ret = FDR_RET_OOPS;
    struct kdp_rect *lp_rect = &m_boundingbox;

    m_fdr_inout->op = KDP_APP_FID_OP_INFERENCE;
    m_fdr_inout->thresh_fid = 0.425;

    do {
        memset(m_fd_out, 0, sizeof(kdp_app_face_det_res_t));
        memset(m_fr_out, 0, sizeof(kdp_app_face_fmap_t));   
        
        // get exp time
        u16 a = 0;
        u8 b, c;
        rgb_get_lux( &a , &b , &c );
        //dbg_msg("exp_rgb_time = %d", a);
			 //dump NIR image
			  //memcpy((const void *) 0x62000000, (const void *) 0x637E7000, 640*480*sizeof(char));
        //memcpy((const void *) 0x62000000, (const void *) 0x6357C400, 640*480*sizeof(char));
		//memcpy((const void *) 0x62000000, (const void *) 0x62FFE000, 640*480*2*sizeof(char));
			
        fdr_ret = _sample_kneron_fdr_both_only(lp_rect);


    } while (0);
    
    return fdr_ret;
}


int sample_kneron_fdr_both_registration_confirm(u32 curr_user_idx) {
	DSG_NOLF(" Registration confrim for id %d!\n", curr_user_idx);
	  int ret = -1;
	    m_fdr_inout->thresh_fid = 0.425;
	  int near_cnt = 0;
    //need to check if the user is already in db??
    for (int i = 0; i<NUM_REG_INFERENCE; i++) {
			//DSG_NOLF("check %d FM!\n", i);
        if (db_tmp_valid_pose[i]) {
					//DSG_NOLF("valid pose %d!\n", i);
            ret = kdp_app_db_compare((uint32_t)&db_tmp_fr[i*512], &m_fdr_inout->user_id, m_fdr_inout->thresh_fid);
            if(ret != KDP_APP_DB_NO_MATCH) {
							  DSG_NOLF("%d FM match with %d in database!\n", i, m_fdr_inout->user_id);
							  near_cnt++;
							  db_tmp_valid_pose[i] = 0;
                //return KDP_APP_DB_ALREADY_SAVED; // person already in DB ?? 
            }
        }
        //KDP_APP_DB_NO_MATCH
    }
		if (near_cnt>5) {
			DSG_NOLF("more than 5 FM are too close to those in database!\n");
			return KDP_APP_DB_ALREADY_SAVED; // person already in DB ?? 
		}
    //check best pose for registration

    int index[5], index1[5], index2[5], index3[5], index4[5];

    float tmp_lm[5];
    float min_lm[5];
    float min_lm1[5], min_lm2[5], min_lm3[5], min_lm4[5];
    //initialize
    for (int i=0; i<5; i++) {
        min_lm[i]  = 1000;
        min_lm1[i] = 1000;
        min_lm2[i] = 1000;
        min_lm3[i] = 1000;
        min_lm4[i] = 1000;
        index[i]  = 0;
        index1[i] = 0;
        index2[i] = 0;
        index3[i] = 0;
        index4[i] = 0;
    }   
    DSG_NOLF("check for best pose!\n");
    for (int i=0;i<NUM_REG_INFERENCE;i++) {
        if (db_tmp_valid_pose[i]) {
			DSG_NOLF("pose number %d!\n",i);
            kdp_app_get_pose_value(&db_tmp_lm[i*10], tmp_lm);
            for (int j=0; j<5; j++) {
				bool change = FALSE;
                if (tmp_lm[j] < min_lm[j]) {
                    index[j] = i;
                    min_lm[j] = tmp_lm[j];
					change = TRUE;
                }
                if (!change && (tmp_lm[j] < min_lm1[j])) {
                        index1[j] = i;
                        min_lm1[j] = tmp_lm[j];
                        change = TRUE;
                }
                if (!change && (tmp_lm[j] < min_lm2[j])) {
                    index2[j] = i;
                        min_lm2[j] = tmp_lm[j];
                        change = TRUE;
                }
                if (!change && (tmp_lm[j] < min_lm3[j])) {
                        index3[j] = i;
                        min_lm3[j] = tmp_lm[j];
                        change = TRUE;
                }
                if (!change && (tmp_lm[j] < min_lm4[j])) {
                        index4[j] = i;
                        min_lm4[j] = tmp_lm[j];
                        change = TRUE;
                }
            }
        }
    }
    //check if index has repeated 
    DSG_NOLF("check if any index is repeat!\n");
    int target;
    for (int i= 0; i<5; i++) {
        target = index[i];
        bool repeat = FALSE; 
        for (int j=0; j<5; j++) {
            if ((i!=j)&&(target == index[j])) {
                repeat = TRUE;
                break;
            }
        }
        if (!repeat) {
            DSG_NOLF("keep index %d for pose %d!\n", target, i);
            index[i] = target;
            continue;
        }	 
        target = index1[i];
        repeat = FALSE;			 
        for (int j=0; j<5; j++) {
            if ((i!=j)&&(target == index[j])) {
                repeat = TRUE;
                break;
            }
        }
        if (!repeat) {
            DSG_NOLF("replace min 1 index %d for pose %d!\n", target, i);
            index[i] = target;
            continue;
        }	 				 	 
        target = index2[i];
        repeat = FALSE;			 
        for (int j=0; j<5; j++) {
            if ((i!=j)&&(target == index[j])) {
                    repeat = TRUE;
                    break;
            }
        }
        if (!repeat) {
            DSG_NOLF("replace min 2 index %d for pose %d!\n", target, i);
            index[i] = target;
            continue;
        }					 
        target = index3[i];
        repeat = FALSE;			 
        for (int j=0; j<5; j++) {
            if ((i!=j)&&(target == index[j])) {
                    repeat = TRUE;
                    break;
            }
        }
        if (!repeat) {
            DSG_NOLF("replace min 3 index %d for pose %d!\n", target, i);
            index[i] = target;
            continue;
        }
        target = index4[i];
        repeat = FALSE;			 
        for (int j=0; j<5; j++) {
            if ((i!=j)&&(target == index[j])) {
                    repeat = TRUE;
                    break;
            }
        }
        if (!repeat) {
            DSG_NOLF("replace min 4 index %d for pose %d!\n", target, i);
            index[i] = target;
            continue;
        }			 
	}
    DSG_NOLF("best pose index %d %d %d %d %d!\n", index[0], index[1], index[2], index[3], index[4]);
    //check if these lm valid
    for (int i=0; i<5; i++) {
        if (!db_tmp_valid_pose[index[i]]) {
            DSG_NOLF("not enough valid pose in registration!\n");
            ret = KDP_APP_FDR_BAD_POSE;
            return ret;
        }
    }	
	DSG_NOLF("register for user id %d!\n", curr_user_idx);
    for (int i=0; i<5; i++) {
        uint32_t rgb_fr_addr = (uint32_t)db_tmp_fr+index[i]*512*4;
        uint32_t nir_fr_addr = (uint32_t)db_tmp_1_fr+index[i]*512*4;        
		//DSG_NOLF("db_tmp_fr addr is %d, index[i]*512 is %d, fr_addr is %d!\n", db_tmp_fr, index[i]*512, fr_addr);
        ret = kdp_app_db_both_register(rgb_fr_addr, nir_fr_addr, curr_user_idx, i+1);		 
    }   
	
	return ret;
}
//todo should be static
int sample_kneron_fdr_registration_confirm(u32 curr_user_idx) {
	DSG_NOLF(" Registration confrim for id %d!\n", curr_user_idx);
	  int ret = -1;
	    m_fdr_inout->thresh_fid = 0.425;
	  int near_cnt = 0;
    //need to check if the user is already in db??
    for (int i = 0; i<NUM_REG_INFERENCE; i++) {
		//DSG_NOLF("check %d FM!\n", i);
        if (db_tmp_valid_pose[i]) {
			//DSG_NOLF("valid pose %d!\n", i);
            ret = kdp_app_db_compare((uint32_t)&db_tmp_fr[i*512], &m_fdr_inout->user_id, m_fdr_inout->thresh_fid);
            if(ret != KDP_APP_DB_NO_MATCH) {
				//DSG_NOLF("%d FM match with %d in database!\n", i, m_fdr_inout->user_id);
				near_cnt++;
				db_tmp_valid_pose[i] = 0;
                //return KDP_APP_DB_ALREADY_SAVED; // person already in DB ?? 
            }
        }
        //KDP_APP_DB_NO_MATCH
    }
		if (near_cnt>5) {
			DSG_NOLF("more than 5 FM are too close to those in database!\n");
			return KDP_APP_DB_ALREADY_SAVED; // person already in DB ?? 
		}
    //check best pose for registration

    int index[5], index1[5], index2[5], index3[5], index4[5];

    float tmp_lm[5];
    float min_lm[5];
    float min_lm1[5], min_lm2[5], min_lm3[5], min_lm4[5];
    //initialize
    for (int i=0; i<5; i++) {
        min_lm[i]  = 1000;
        min_lm1[i] = 1000;
        min_lm2[i] = 1000;
        min_lm3[i] = 1000;
        min_lm4[i] = 1000;
        index[i]  = 0;
        index1[i] = 0;
        index2[i] = 0;
        index3[i] = 0;
        index4[i] = 0;
    }   
    DSG_NOLF("check for best pose!\n");
    for (int i=0;i<NUM_REG_INFERENCE;i++) {
        if (db_tmp_valid_pose[i]) {
			//DSG_NOLF("pose number %d!\n",i);
            kdp_app_get_pose_value(&db_tmp_lm[i*10], tmp_lm);
            for (int j=0; j<5; j++) {
				bool change = FALSE;
                if (tmp_lm[j] < min_lm[j]) {
                    index[j] = i;
                    min_lm[j] = tmp_lm[j];
					change = TRUE;
                }
                if (!change && (tmp_lm[j] < min_lm1[j])) {
                        index1[j] = i;
                        min_lm1[j] = tmp_lm[j];
                        change = TRUE;
                }
                if (!change && (tmp_lm[j] < min_lm2[j])) {
                    index2[j] = i;
                        min_lm2[j] = tmp_lm[j];
                        change = TRUE;
                }
                if (!change && (tmp_lm[j] < min_lm3[j])) {
                        index3[j] = i;
                        min_lm3[j] = tmp_lm[j];
                        change = TRUE;
                }
                if (!change && (tmp_lm[j] < min_lm4[j])) {
                        index4[j] = i;
                        min_lm4[j] = tmp_lm[j];
                        change = TRUE;
                }
            }
        }
    }
    //check if index has repeated 
    //DSG_NOLF("check if any index is repeat!\n");
    int target;
    for (int i= 0; i<5; i++) {
        target = index[i];
        bool repeat = FALSE; 
        for (int j=0; j<5; j++) {
            if ((i!=j)&&(target == index[j])) {
                repeat = TRUE;
                break;
            }
        }
        if (!repeat) {
            //DSG_NOLF("keep index %d for pose %d!\n", target, i);
            index[i] = target;
            continue;
        }	 
        target = index1[i];
        repeat = FALSE;			 
        for (int j=0; j<5; j++) {
            if ((i!=j)&&(target == index[j])) {
                repeat = TRUE;
                break;
            }
        }
        if (!repeat) {
            //DSG_NOLF("replace min 1 index %d for pose %d!\n", target, i);
            index[i] = target;
            continue;
        }	 				 	 
        target = index2[i];
        repeat = FALSE;			 
        for (int j=0; j<5; j++) {
            if ((i!=j)&&(target == index[j])) {
                    repeat = TRUE;
                    break;
            }
        }
        if (!repeat) {
            //DSG_NOLF("replace min 2 index %d for pose %d!\n", target, i);
            index[i] = target;
            continue;
        }					 
        target = index3[i];
        repeat = FALSE;			 
        for (int j=0; j<5; j++) {
            if ((i!=j)&&(target == index[j])) {
                    repeat = TRUE;
                    break;
            }
        }
        if (!repeat) {
            //DSG_NOLF("replace min 3 index %d for pose %d!\n", target, i);
            index[i] = target;
            continue;
        }
        target = index4[i];
        repeat = FALSE;			 
        for (int j=0; j<5; j++) {
            if ((i!=j)&&(target == index[j])) {
                    repeat = TRUE;
                    break;
            }
        }
        if (!repeat) {
            //DSG_NOLF("replace min 4 index %d for pose %d!\n", target, i);
            index[i] = target;
            continue;
        }			 
	}
    DSG_NOLF("best pose index %d %d %d %d %d!\n", index[0], index[1], index[2], index[3], index[4]);
    //check if these lm valid
    for (int i=0; i<5; i++) {
        if (!db_tmp_valid_pose[index[i]]) {
            info_msg("ERROR! not enough valid pose in registration!");
            ret = KDP_APP_FDR_BAD_POSE;
            return ret;
        }
    }	
	//DSG_NOLF("register for user id %d!\n", curr_user_idx);
    for (int i=0; i<5; i++) {
        uint32_t fr_addr = (uint32_t)db_tmp_fr+index[i]*512*4;
		//DSG_NOLF("db_tmp_fr addr is %d, index[i]*512 is %d, fr_addr is %d!\n", db_tmp_fr, index[i]*512, fr_addr);
        ret = kdp_app_db_register(fr_addr, curr_user_idx, i+1);		 
    }   
	
	return ret;
}


int sample_kneron_fdr_add_user(u32 curr_user_idx)
{
    int ret = -1;

    do {
        //todo no need
        if ((curr_user_idx + 1) > DB_SLOT_SIZE) /*User id(curr_user_idx) starts from 0*/
        {
            info_msg("[add_user] : No space\n");
            break;
        }        

        m_db_data->user_id_in = (uint16_t)curr_user_idx;
        ret = kdp_app_db_add(m_db_data);

        if (KDP_APP_OK == ret) { 
            info_msg("[add_user] : UID:%d, OK!\n", curr_user_idx);
        }
        else {
            info_msg("[add_user] : UID:%d, ERROR!, ret=%x\n", curr_user_idx, ret);
            break;
        }

    } while (0);
    
    return ret;
}

int sample_kneron_fdr_del_user(unsigned char all, u32 curr_user_idx)//int user_id)
{
    int ret = -1;
    do {    
        if (all)
            m_db_data->del_all = TRUE;
        else {
            m_db_data->del_all = FALSE;
            m_db_data->user_id_in = (uint16_t)curr_user_idx;
        }
        ret = kdp_app_db_delete(m_db_data);
        if (KDP_APP_OK == ret) {
            info_msg("[delete user face] delete user face -- OK!\n");
        }
        else {
            info_msg("[delete user face] delete user face -- ERROR, ret=%x\n", ret);
            break;            
        }
        
        ret = 0;
        
    } while (0);
    
    return ret;    
}

int sample_kneron_fdr_cancel(void)
{
    int ret = -1;

    /* under construction */
    do {    
         ret = kdp_app_db_abort_reg();      
         if (KDP_APP_OK == ret) { 
             info_msg("[cancel registration] -- OK!\n");
         } else {
             info_msg("[cancel registration] -- ERROR!, err=%x\n", ret);
         }
         ret = 0;    
    } while (0);
    
    //0808@customer1 should release the memory which alloc in sample_kneron_fdr_model_init();  
    return ret;
}

int sample_kneron_fdr_abort(void)
{
    /* under construction */
    do {    
         kdp_app_abort();      
         info_msg("[abort model operations] -- OK!\n");
    } while (0);
    
    return 0;
}
