
#ifdef BOARD_CUSTOMER1
#include "touch_panel.h"
#include <cmsis_os2.h>
#include "base.h"
#include "pinmux.h"
#include "framework/framework_driver.h"
#include "kdp520_gpio.h"
#include "kdp_i2c.h"
#include "dbg.h"
#include "ui_fsm_proto.h"
#include "user_ui.h"
#include "sample_app_touch.h"

#define USE_API_STYLE

extern void set_thread_event(osThreadId_t id, unsigned int flags);
extern u32 flag_lcd_display_evt_0;
extern u32 flag_lcd_display_evt_1;
extern u32 flag_lcd_display_evt_2;
extern u32 flag_lcd_display_evt_3;
extern u32 flag_lcd_display_evt_4;
extern u32 flag_lcd_display_evt_5;
extern osThreadId_t tid_ui_fsm;
#define MAX_TOUCH_NUM	5
//extern struct core_device kdp520_i2c_0;
//extern struct core_i2c_driver kdp520_i2c_0_driver;
extern u32 flag_app_touchpanel_evt;
extern osThreadId_t tid_touchpanel;


void GPIO010_IRQHandler(void)
{
    u32 IntrMaskedStat;
    u8 i;

    IntrMaskedStat = kdp520_gpio_getintmaskstatus();
    //clear CPIO interrupt
    kdp520_gpio_clearint(IntrMaskedStat);
    //__gpio_int_occurred |= IntrMaskedStat;
    kdp520_set_int_occurred(IntrMaskedStat);

    for (i=0; i<32; ++i)
    {
        if((IntrMaskedStat&(1<<i))!= 0)
        {
            //fLib_printf("GPIO %d has been triggered!\n", i);
            if (27 == i)
            {
                set_thread_event(tid_touchpanel, flag_app_touchpanel_evt);
            }
        }
    }
}

void touch_get_raw_data(u8 init_i2c)
{
	u8 buf[30] = {0};
	u8 i2c_buf[8] = {0};
	u8 cnt, i2c_len, idx, len_1=0, len_2=0;
	u16 i;
	//u8 finger_id;
	u32 input_x=0, input_y=0;
	u16 regAddr;
	int dev_addr = 0x1A;
	
	if (1 == init_i2c)
    {
    #ifndef USE_API_STYLE
        struct kdp520_i2c_params params;
        params.bus_speed = 200000;
        kdp520_i2c_0_driver.probe(&kdp520_i2c_0);
        kdp520_i2c_0_driver.set_params(&kdp520_i2c_0, &params);
        kdp520_i2c_0_driver.init(&kdp520_i2c_0);
        kdp520_i2c_0_driver.reset(&kdp520_i2c_0);
    #else
            //api style
        #if I2C_0_ENABLE == YES
        kdp_i2c_init(KDP_I2C_CTRL_0, KDP_I2C_SPEED_200K);
        //kdp_drv_i2c_init(I2C_ADAP_0, 200000, FALSE);
        #endif
    #endif
	}
		
	regAddr = 0xD000;
#ifndef USE_API_STYLE    
    kdp520_i2c_0_driver.readbytes(&kdp520_i2c_0, dev_addr, regAddr, 2, buf, 7);
#else
    kdp_i2c_receive(KDP_I2C_CTRL_0, dev_addr, regAddr, 2, 7, buf);
    //kdp_drv_i2c_read_bytes(I2C_ADAP_0, dev_addr, regAddr, 2, buf, 7); //api style
#endif

    if (0xAB!=buf[6] || 0x80==buf[5])
        goto OUT_PROCESS;

    cnt = buf[5] & 0x7F;
    if (MAX_TOUCH_NUM<cnt || 0==cnt)
    goto OUT_PROCESS;
    if (1 == cnt)
        goto FINGER_PROCESS;
    else
    {
        i2c_len = (cnt-1)*5 + 1;
        len_1 = i2c_len;

        for(idx=0; idx<i2c_len; idx+=6)
        {
            regAddr = 0xD007+idx;
            if(len_1>=6) {
                len_2  = 6;
                len_1 -= 6;
            }
            else {
                len_2 = len_1;
                len_1 = 0;
            }

#ifndef USE_API_STYLE       
            kdp520_i2c_0_driver.readbytes(&kdp520_i2c_0, dev_addr, regAddr, 2, i2c_buf, len_2);
#else      
            kdp_i2c_receive(KDP_I2C_CTRL_0, dev_addr, regAddr, 2, len_2, i2c_buf);
            //kdp_drv_i2c_read_bytes(I2C_ADAP_0, dev_addr, regAddr, 2, i2c_buf, len_2); //api style
#endif      

            for(i=0; i<len_2; i++)
                buf[5+idx+i] = i2c_buf[i];
        }
        i2c_len += 5;

        if (buf[i2c_len - 1] != 0xAB)
            goto OUT_PROCESS;
    }

FINGER_PROCESS:
	regAddr = 0xD000;
	i2c_buf[2] = 0xAB;
    
#ifndef USE_API_STYLE
	kdp520_i2c_0_driver.write(&kdp520_i2c_0, dev_addr, regAddr, 2, &i2c_buf[2]);
#else
    kdp_i2c_transmit(KDP_I2C_CTRL_0, dev_addr, regAddr, 2, 1, &i2c_buf[2]);
	//kdp_drv_i2c_write(I2C_ADAP_0, dev_addr, regAddr, 2, i2c_buf[2]); //api style
#endif
    
	idx = 0;
	sample_app_touch_count_setting(cnt);
	//DSG("touch cnt : %d.\n", cnt);
	for (i = 0; i < cnt; i++) {
	    input_x = (unsigned int)((buf[idx + 1] << 4) | ((buf[idx + 3] >> 4) & 0x0F));
	    input_y = (unsigned int)((buf[idx + 2] << 4) | (buf[idx + 3] & 0x0F));
	    //finger_id = (buf[idx] >> 4) & 0x0F;
	    //input_x = TPD_MAX_X*input_x/480;
	    //input_y = TPD_MAX_Y*input_y/800;
		//DSG("x : %d, y : %d, id : %d.\n", input_x, input_y, finger_id);
		idx += 5;
		sample_app_touch_point_setting(i, input_x, input_y);
    }
	goto END;

OUT_PROCESS:
	regAddr = 0xD000;
	buf[2] = 0xAB;
#ifndef USE_API_STYLE  
	kdp520_i2c_0_driver.write(&kdp520_i2c_0, dev_addr, regAddr, 2, &buf[2]);
#else
    kdp_i2c_transmit(KDP_I2C_CTRL_0, dev_addr, regAddr, 2, 1, &buf[2]);
    //kdp_drv_i2c_write(I2C_ADAP_0, dev_addr, regAddr, 2, buf[2]); //api style
#endif  
END:
	return;
}

void init_touch_panel(void)
{
	//sd_data3
	u8 i = 27;
	u8 data = 0x3;//inw(SCU_EXTREG_PA_BASE + 0x190);
	outw(SCU_EXTREG_PA_BASE + 0x190, data);// | 0x3); //gpio 27
	kdp520_gpio_setdir(i, GPIO_DIR_INPUT);
	kdp520_gpio_setedgemode(i, SINGLE);
	kdp520_gpio_settrigger(i, GPIO_EDGE);
	kdp520_gpio_setactivemode(i, GPIO_Rising);
	//clear CPIO interrupt
	kdp520_gpio_clearint(1<<i);
	kdp520_gpio_enablebounce(i, APB_CLOCK /12000); //
	//Enable GPIO interrupt
	kdp520_gpio_setintenable(i);
	kdp520_gpio_setintunmask(i);
    
    NVIC_SetVector((IRQn_Type)GPIO_FTGPIO010_IRQ, (uint32_t)GPIO010_IRQHandler);
	NVIC_EnableIRQ(GPIO_FTGPIO010_IRQ); 
}
#endif
