#include <stdio.h>
#include "ui_fsm_proto.h"
#include "user_ui.h"

extern user_behavior_ui_interface *get_ui_interface(void);

static void __dummy_push(user_behavior_type type,unsigned short data);
static void __dummy_push(user_behavior_type type,unsigned short data){
    //default - dummy : do nothing
}
static void __dummy_run(void *param);
static void __dummy_run(void *param){
    //default - dummy : do nothing
}

static const user_behavior_ui_interface __dummy_temp_ui_interface =
{
    .task_run = __dummy_run,
    .push_event = __dummy_push,
    .is_run = 0
};
extern user_behavior_ui_interface *ui_fsm = (user_behavior_ui_interface *)&__dummy_temp_ui_interface;

extern void create_fsm(int type)
{
    user_behavior_ui_interface *__x = NULL;

    switch (type){
        case DEVICE_TYPE_CUSTOMER1:
            __x = get_ui_interface();
            break;
        default:
            break;
    }

    if ( __x != NULL){
        ui_fsm = __x;
    }
}

extern void notify_user_behavior_event(user_behavior_type type,unsigned short data)
{
    ui_fsm->push_event(type,data);
}
