#pragma once

typedef enum __user_behavior_type
{
    TYPE_NULL = -1,
    UI_RETURN_TO_FRONT_PAGE = 0,
    UI_RETURN_TO_MAIN_MENU,
    UI_OPEN_REGISTER,
    UI_START_REGISTER,
    UI_INFERENCE,
    UI_DELETE_ALL,
} user_behavior_type;//one byte

struct __user_behavior_data
{
    user_behavior_type type;
    int data;
};
typedef struct __user_behavior_data user_behavior_data;

struct __user_behavior_ui_interface
{
    void (*task_run)(void *param);
    void (*push_event)(user_behavior_type type,unsigned short data);
    unsigned char is_run;
};
typedef struct __user_behavior_ui_interface user_behavior_ui_interface;

extern user_behavior_ui_interface* ui_fsm;

extern void create_fsm(int type);
extern user_behavior_ui_interface *get_ui_interface(void);
extern void notify_user_behavior_event(user_behavior_type type,unsigned short data);
