/*
 * Kneron Peripheral API
 *
 * Copyright (C) 2019 Kneron, Inc. All rights reserved.
 *
 */

#ifndef __KDP_PERIPHERAL_H__
#define __KDP_PERIPHERAL_H__

typedef enum{
    KDP_STATUS_OK = 0,
    KDP_STATUS_ERROR,
    KDP_STATUS_ERROR_CTRL_NO_EXIST,
    KDP_STATUS_ERROR_CTRL_INITIALIZED,
    KDP_STATUS_ERROR_CTRL_UNINITIALIZED,
    KDP_STATUS_ERROR_NO_MEMORY,
    KDP_STATUS_ERROR_I2C_RESET_FAILED,
    KDP_STATUS_ERROR_I2C_BUS_BUSY,
    KDP_STATUS_ERROR_I2C_DEV_NACK,
    KDP_STATUS_ERROR_I2C_STATUS_TIMEOUT,
    KDP_STATUS_ERROR_USBD_INVALID_ENDP,  // usbd: invalid endpoint
    KDP_STATUS_ERROR_USBD_BUF_COMMITED,  // usbd: a buffer is already commited for transfer
    KDP_STATUS_ERROR_USBD_INVALID_TX_SIZE,  // usbd: invalid transfer size
    KDP_STATUS_ERROR_USBD_TRANSFER_TIMEOUT, // usbd: transfer timeout
    KDP_STATUS_ERROR_USBD_INVALID_TRANSFER, // usbd: invalid transfer operation
    KDP_STATUS_ERROR_USBD_TRANSFER_IN_PROGRESS, // usbd: transfer is in progress
}kdp_status_e;

typedef enum{
    KDP_BOOL_TRUE = 1,
    KDP_BOOL_FALSE = 0
}kdp_bool_e;

typedef void (*kdp_user_callback_t)(void *data);

// including all perihperal related header files here
#include "kdp_pinconfig.h"
#include "kdp_gpio.h"
#include "kdp_i2c.h"
#include "kdp_spi.h"
#include "kdp_uart.h"
#include "kdp_usbd.h"

#endif
