#ifndef __SENSOR_H__
#define __SENSOR_H__


#include "framework/framework_driver.h"


struct sensor_device {
    //struct i2c_adapter *adapter;        /* the adapter we sit on	*/
    struct pin_context pin_ctx;         /* the pin_context structure */ // sys_camera_device->control
    unsigned short addr;                /* chip address - NOTE: 7bit */
};
#define to_sensor_device(d) container_of(d, struct sensor_device, pin_ctx)

//struct sensor_device;
struct sensor_driver {
    int (*probe)(struct sensor_device *);
    int (*remove)(struct sensor_device *);

    struct core_device *core_dev;
    struct driver_context driver;
};
#define to_sensor_driver(__adap__) container_of(__adap__, struct sensor_driver, driver)

int sensor_driver_register(struct sensor_driver *);
void sensor_driver_unregister(struct sensor_driver *);

#define KDP_SENSOR_DRIVER_SETUP(__sensor_driver) \
    DRIVER_SETUP(__sensor_driver, 3, sensor_driver_register, sensor_driver_unregister)

//sensor APIs
void rgb_set_aec_roi(u8 x1, u8 x2, u8 y1, u8 y2, u8 center_x1, u8 center_x2, u8 center_y1, u8 center_y2);
void rgb_get_lux(u16* exposure, u8* pre_gain, u8* post_gain);
void nir_set_gain(u8 ana_gn1, u8 ana_gn2);
void nir_led_open(void);
void nir_led_close(void);

#endif 
