#ifndef __KDP_DISPLAY_H__
#define __KDP_DISPLAY_H__

#include "framework/v2k_image.h"

struct display_driver_ops {
    void (*wait_ready)(unsigned int base);
    void (*write_cmd)(unsigned int base, unsigned char data);
    void (*write_data)(unsigned int base, unsigned char data);
    unsigned int (*read_data)(unsigned int base);
};

int kdp_display_pip_test(void);
int kdp_display_set_pen(unsigned char r, unsigned char g, unsigned char b, int pen_width);
int kdp_display_draw_rect(unsigned int fb_addr, int x, int y, int width, int height, int draw_mode);



/**
 * @brief open a video renderer.
 * @param cam_idx,  choose which camera the image source comes from.
 * @param width,    video width
 * @param height,   video height
 * @return 0,       if kdp_video_renderer_open was successfully, or
 *         others,  if an error occurred
 */
//int kdp_video_renderer_open(unsigned int cam_idx, int width, int height);
int kdp_video_renderer_open(struct video_input_params *params);

/**
 * @brief choose which camera the image source comes from.
 * @param cam_idx,  camera device index
 * @return 0,       if kdp_video_renderer_set_camera was successfully, or
 *         others,  if an error occurred
 */
int kdp_video_renderer_set_camera(unsigned int cam_idx);
/**
 * @brief start video renderer.
 * @return 0,       if kdp_video_renderer_start was successfully, or
 *         others,  if an error occurred
 */
int kdp_video_renderer_start(void);
/**
 * @brief stop video renderer.
 * @return 0,       if kdp_video_renderer_stop was successfully, or
 *         others,  if an error occurred
 */
int kdp_video_renderer_stop(void);


#endif // __KDP_DISPLAY_H__
