/*
 * KDP Frame Buffer driver header
 *
 * Copyright (C) 2019 Kneron, Inc. All rights reserved.
 *
 */

#ifndef __KDP_FB_MGR_H__
#define __KDP_FB_MGR_H__
#include <stdint.h>

#define MAX_FRAME_BUFFER        6

typedef int (*fb_write_done_notify)(int cam_idx, int write_idx);

int kdp_fb_mgr_init(int cam_idx, uint32_t buf_size, int buf_num);

uint32_t kdp_fb_mgr_next_write(int cam_idx, int *write_idx);

int kdp_fb_mgr_write_done(int cam_idx, int write_idx);

void kdp_fb_mgr_free_write_buf(int cam_idx);

uint32_t kdp_fb_mgr_get_buf(int cam_idx, int idx);

uint32_t kdp_fb_mgr_get_buf_seq_num(int cam_idx, int idx);

uint32_t kdp_fb_mgr_next_read(int cam_idx, int *read_idx);

void kdp_fb_mgr_free_read_buf(int cam_idx);

uint32_t kdp_fb_mgr_next_inf(int cam_idx, int *inf_idx);

int kdp_fb_mgr_inf_done(int cam_idx, int inf_idx);

void kdp_fb_mgr_free_inf_buf(int cam_idx);

int kdp_fb_mgr_notifier_register(int cam_idx, fb_write_done_notify callback);

#endif // __KDP_FB_MGR_H__
