/*
 * KDP Sensor driver header
 *
 * Copyright (C) 2019 Kneron, Inc. All rights reserved.
 *
 */

#ifndef __KDP_SENSOR_H__
#define __KDP_SENSOR_H__

#include <cmsis_os2.h>
#include "media/kdp_camera.h"
#include "base.h"

struct sensor_ops {
    int (*s_power)(int sensor_id, int on);
    int (*reset)(int sensor_id);
    int (*s_stream)(int sensor_id, int enable);
    int (*enum_fmt)(int sensor_id, unsigned int index, unsigned int *fourcc);
    int (*get_fmt)(int sensor_id, struct cam_format *format);
    int (*set_fmt)(int sensor_id, struct cam_format *format);
    u16 (*get_device_id)(void);
};

int kdp_sensor_s_power(int sensor_idx, int on);

int kdp_sensor_reset(int sensor_idx);

int kdp_sensor_s_stream(int sensor_idx, int enable);

int kdp_sensor_enum_fmt(int sensor_idx, unsigned int index, unsigned int *fourcc);

int kdp_sensor_set_fmt(int sensor_idx, struct cam_format *format);

int kdp_sensor_get_fmt(int sensor_idx, struct cam_format *format);

int kdp_sensor_register(int sensor_idx, struct sensor_ops *sensor_ops_p);

int kdp_sensor_unregister(int sensor_idx, struct sensor_ops *sensor_ops_p);

#endif // __KDP_SENSOR_H__
