/*
 * Kneron Peripheral API
 *
 * Copyright (C) 2019 Kneron, Inc. All rights reserved.
 *
 */

#include <stdarg.h>
#include "kdp_pinconfig.h"
#include "scu_extreg.h"
#include "base.h"

void kdp_pinconfig_set_pin_mode(kdp_pin_name_e pin, kdp_pin_mode_t mode, kdp_pin_pull_t pull_type)
{
    uint32_t reg_addr = SCU_EXTREG_SPI_WP_N_IOCTRL + (pin * 4);
    uint32_t pullbits;

    if(pull_type == PIN_PULL_UP)
        pullbits = BIT3;
    else if(pull_type == PIN_PULL_DOWN)
        pullbits = BIT4;
    else
        pullbits = 0;

    PINMUX_SET(reg_addr, mode);
    masked_outw(reg_addr, pullbits, (BIT3 | BIT4));
}
