#ifndef __BOARD_KDP520_CUSTOMER1_H__
#define __BOARD_KDP520_CUSTOMER1_H__


#define YES                         1
#define NO                          0

/* PRE-definition for board configuration */
#define V2K_ENABLE_HMX2056          1
#define V2K_ENABLE_OV9286           2
#define V2K_ENABLE_HMX2056_OV9286   3
#define V2K_ENABLE_HMXRICA          4
#define V2K_ENABLE_GC2145           5
#define V2K_ENABLE_SC132GS          6
#define V2K_ENABLE_GC2145_SC132GS   7
#define V2K_ENABLE_SC132GS_GC2145   8

#define SENSOR_TYPE_HMX2056         0
#define SENSOR_TYPE_OV9286          1
#define SENSOR_TYPE_HMXRICA         2
#define SENSOR_TYPE_GC2145          3
#define SENSOR_TYPE_SC132GS         4

#define RES_640_480                 0
#define RES_480_640                 1
#define RES_480_272                 2
#define RES_272_480                 3

#define IMAGE_FORMAT_RGB565         0
#define IMAGE_FORMAT_RAW10          1
#define IMAGE_FORMAT_RAW8           2
#define IMAGE_FORMAT_YCBCR          3

#define IMAGE_MIPILANE_NUM_1        1
#define IMAGE_MIPILANE_NUM_2        2

#define DISPLAY_DEVICE_LCDC         0
#define DISPLAY_DEVICE_LCM          1

#define PANEL_MZT_480X272           1
#define PANEL_ST7789_240X320        2

/* customer board configuration */
#define I2C_0_ENABLE                YES
#define I2C_1_ENABLE                NO
#define I2C_2_ENABLE                NO
#define I2C_3_ENABLE                NO

#define MIPI_0_RX_ENABLE            YES
#define MIPI_1_RX_ENABLE            YES

#define V2K_ENABLE_TYPE             V2K_ENABLE
#if (V2K_ENABLE_TYPE == V2K_ENABLE_GC2145_SC132GS)
#define IMGSRC_0_TYPE               SENSOR_TYPE_GC2145
#define IMGSRC_1_TYPE               SENSOR_TYPE_SC132GS
#define IMGSRC_0_RES                RES_640_480
#define IMGSRC_1_RES                RES_480_640
#define IMGSRC_0_FORMAT             IMAGE_FORMAT_RGB565
#define IMGSRC_1_FORMAT             IMAGE_FORMAT_RAW8
#elif (V2K_ENABLE_TYPE == V2K_ENABLE_SC132GS_GC2145)
#define IMGSRC_0_TYPE               SENSOR_TYPE_SC132GS
#define IMGSRC_1_TYPE               SENSOR_TYPE_GC2145
#define IMGSRC_0_RES                RES_480_640
#define IMGSRC_1_RES                RES_640_480
#define IMGSRC_0_FORMAT             IMAGE_FORMAT_RAW8
#define IMGSRC_1_FORMAT             IMAGE_FORMAT_RGB565
#elif (V2K_ENABLE_TYPE == V2K_ENABLE_HMX2056_OV9286)
#define IMGSRC_0_TYPE               SENSOR_TYPE_HMX2056
#define IMGSRC_1_TYPE               SENSOR_TYPE_OV9286
#define IMGSRC_0_RES                RES_640_480
#define IMGSRC_1_RES                RES_640_480
#define IMGSRC_0_FORMAT             IMAGE_FORMAT_RGB565
#define IMGSRC_1_FORMAT             IMAGE_FORMAT_RAW8
#endif
#define IMGSRC_0_MIPILANE_NUM       IMAGE_MIPILANE_NUM_2
#define IMGSRC_1_MIPILANE_NUM       IMAGE_MIPILANE_NUM_2

#if defined(BOARD_CUSTOMER1) && !defined(BOARD_96)
#define PANEL_TYPE                  PANEL_ST7789_240X320 
#else
#define PANEL_TYPE                  PANEL_MZT_480X272
#endif

/* user-defined ddr allocation table. the maximum is up to 0x03FFFFFF */
#if 1
#define DDR_OFFSET_RGB_TO_NCPU      0x02FFE000 //0x62FFE000
#define DDR_OFFSET_RGB_TO_REST      0x0315D900 //0x6315D900
#define DDR_OFFSET_RGB_PRIMARY      0x032BD200 //0x632BD200
#define DDR_OFFSET_RGB_OVERLAY      0x0341CB00 //0x6341CB00
#define DDR_OFFSET_NIR_TO_NCPU      0x0357C400 //0x6357C400
#define DDR_OFFSET_NIR_TO_REST      0x036DBD00 //0x636DBD00
#define DDR_OFFSET_NIR_PRIMARY      0x0383B600 //0x6383B600
#define DDR_OFFSET_NIR_OVERLAY      0x0399AF00 //0x6399AF00
#else
#define DDR_OFFSET_RGB_TO_NCPU      0x02FFE000
#define DDR_OFFSET_RGB_PRIMARY      0x032A1000
#define DDR_OFFSET_RGB_OVERLAY      0x03544000
#define DDR_OFFSET_NIR_TO_NCPU      0x037E7000
#define DDR_OFFSET_NIR_PRIMARY      0x03A8A000
#define DDR_OFFSET_NIR_OVERLAY      0x03D2D000
#endif

/* The other definitions which are based on customer board configuration */
#if (V2K_ENABLE_TYPE == V2K_ENABLE_HMX2056_OV9286) || \
    (V2K_ENABLE_TYPE == V2K_ENABLE_GC2145_SC132GS) || \
    (V2K_ENABLE_TYPE == V2K_ENABLE_SC132GS_GC2145) 
#   define IMGSRC_NUM               2
#else
#   define IMGSRC_NUM               1
#endif

#if PANEL_TYPE == PANEL_MZT_480X272
#   define DISPLAY_DEVICE           DISPLAY_DEVICE_LCDC
#elif PANEL_TYPE == PANEL_ST7789_240X320
#   define DISPLAY_DEVICE           DISPLAY_DEVICE_LCM
#endif

//#define DISPLAY_FROM_MIPI1

/* DDR */
#define KDP_DDR_BASE_MOZART             0x60000000   //reserved 32MB for models
#define KDP_DDR_MODEL_RESERVED_END      0x61FFFFFF
#define KDP_DDR_USER_IMAGE_BASE_START   0x62000000

#define KDP_DDR_HEAP_HEAD_FOR_MALLOC    0x62FFDFFF

#define KDP_DDR_BASE_IMAGE_FOR_LCM      0x6341CB00//0x62A00000	

#define KDP_IMAGE_BUF_SIZE_FOR_APP      0x96000      //640x480x2(RGB565)
#define KDP_DDR_BASE_IMAGE_FOR_APP      0x62C00000

#define KDP_DDR_BASE_SYSTEM_RESERVED    0x63FD0000   //reserved 191 KB
#define KDP_DDR_MODEL_INFO_TEMP         0x63FFC000   //1KB
#define KDP_DDR_END                     0x63FFFFFF

#endif // __BOARD_KDP520_CUSTOMER1_H__
