/*
 * Kneron Host Communication driver
 *
 * Copyright (C) 2018 Kneron, Inc. All rights reserved.
 *
 */

#ifndef HOST_COM_H
#define HOST_COM_H
#include "base.h"
#include "cmsis_os2.h"

#define FLAG_HOST_COMM_START			BIT(0) 
#define FLAG_HOST_COMM_ISR  			BIT(1)
#define FLAG_HOST_COMM_TIMER			BIT(2)
#define FLAG_HOST_COMM_APP_DONE         BIT(3)      //for tid_appmgr
#define FLAG_HOST_COMM_USB_DONE         BIT(4)
#define FLAG_HOST_COMM_UART_DONE        BIT(5)

#ifdef BOARD_96
#define USB_HOST 0  // 1-> use usb for host interface, 0-> use uart
#else
#define USB_HOST 1  // 1-> use usb for host interface, 0-> use uart
#endif

// error code for cmd parser
#define DEVICE_ID       0x520  // Kneron device id for KL520
#define FW_VERSION      0x00090503  // 0, 9, 5, 3 major, minor, patch, edit
#define NO_ERROR        0
#define NO_MATCH        1
#define RSP_NOT_IMPLEMENTED 0xFFFE
#define RSP_UKNOWN_CMD  0xFFFF
#define BAD_CONFIRMATION 2  // CMD_RESET RESPONSE
#define BAD_MODE         1
#define FILE_ERROR       1  // File data transfer error

/* API */
void host_com_init(void);
int cmd_parser(u8 *buf, int len);
#endif
