#ifndef __OTA_UPDATE_H__
#define __OTA_UPDATE_H__

#include "base.h"

#define SCPU_PARTITION0_START_IN_FLASH    0x2000
#define NCPU_PARTITION0_START_IN_FLASH    0x18000
#define PARTITION_0_CFG_START_IN_FLASH    0X28000

#define SCPU_PARTITION1_START_IN_FLASH    0x41000
#define NCPU_PARTITION1_START_IN_FLASH    0x57000
#define PARTITION_1_CFG_START_IN_FLASH    0X67000

#define SCPU_START_ADDRESS          0x10102000
#define NCPU_START_ADDRESS          0x28000000

#define SCPU_IMAGE_SIZE             0x16000
#define NCPU_IMAGE_SIZE             0x10000
#define PARTITION_CFG_SIZE          32

#define OTA_UPDATE_SUCCESS 0
#define OTA_AUTH_FAIL 251
#define OTA_FLASH_FAIL 252
#define OTA_DOWNLOAD_FAIL 253
int ota_get_active_ncpu_partition(void);
int ota_update_scpu(void);
int ota_update_ncpu(void);
int ota_update_model(u32 model_id, u32 size);
int ota_update_switch_active_partition(u32 partition);
int ota_handle_first_time_boot(void);

#endif
