# scripts to generate configuration file in DME mode

# example for Tiny-YOLO-V3
pre_bypass       = 1
post_bypass      = 0

models_selection = 0x00000001 # Reserved. 0x00000001 if there is only one model
output_num       = 2
image_col        = 224
image_row        = 224
image_ch         = 4
image_format     = 0

if pre_bypass:
    image_format = image_format | 1 << 19 # 1 << 19 to bypass pre

if post_bypass:
    image_format = image_format | 1 << 28 # 1 << 28 to bypass post and output raw results

models_selection   = models_selection.to_bytes(4, byteorder='little')
output_num         = output_num.to_bytes(4, byteorder='little')
image_col          = image_col.to_bytes(4, byteorder='little')
image_row          = image_row.to_bytes(4, byteorder='little')
image_ch           = image_ch.to_bytes(4, byteorder='little')
image_format       = image_format.to_bytes(4, byteorder='little')

img_conf = models_selection + output_num + image_col + image_row + image_ch + image_format

with open("config.bin", 'wb') as binary_file:
    binary_file.write(img_conf)
